Bug 15696 - [3.4/4.0 Regression] ICE with pointer-to-members
Summary: [3.4/4.0 Regression] ICE with pointer-to-members
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: c++ (show other bugs)
Version: 4.0.0
: P2 critical
Target Milestone: 3.4.1
Assignee: Mark Mitchell
URL:
Keywords: ice-on-invalid-code, monitored
Depends on:
Blocks:
 
Reported: 2004-05-28 01:45 UTC by Andrew Pinski
Modified: 2004-10-30 21:11 UTC (History)
2 users (show)

See Also:
Host:
Target:
Build:
Known to work: 3.3.3
Known to fail: 3.4.0 4.0.0
Last reconfirmed: 2004-05-28 13:09:37


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Andrew Pinski 2004-05-28 01:45:56 UTC
class A
{};
class B;
class B:public A
{};
class C
{
        typedef void (A::*ftype)();
        C(B* a){a->*ftype();}
};
Comment 1 Andrew Pinski 2004-05-28 01:47:37 UTC
prtgddbgfd.cc: In constructor `C::C(B*)':
prtgddbgfd.cc:9: internal compiler error: in gimplify_expr, at gimplify.c:3471
Please submit a full bug report,
with preprocessed source if appropriate.
See <URL:http://gcc.gnu.org/bugs.html> for instructions.

Been failing since at least 3.5-tree-ssa 20040512.
Comment 2 Volker Reichelt 2004-05-28 13:09:34 UTC
Confirmed.

Stripping away unneccesary classes I get the following testcase:

========================================
struct A {};

typedef void (A::*ftype)();

void foo(A a) { a.*ftype(); }
========================================

Slightly modifing the last line, I get a testcase that already crashes
with gcc 3.4.0:

========================================
struct A {};

typedef void (A::*ftype)();

void foo() { A().*ftype(); }
========================================

PR15696.cc: In function `void foo()':
PR15696.cc:5: internal compiler error: in cxx_expand_expr, at cp/expr.c:101
Please submit a full bug report, [etc.]
Comment 3 Mark Mitchell 2004-05-28 20:01:32 UTC
The first case in Comment #2 works in GCC 3.4.1.  Is the second case a regression?
Comment 4 Andrew Pinski 2004-05-28 20:04:17 UTC
Yes it used to work in 3.3.3.
Comment 5 Mark Mitchell 2004-05-31 17:08:17 UTC
Working on a fix.
Comment 6 Mark Mitchell 2004-05-31 17:09:43 UTC
This code is invalid because [expr.mptr.operator] requires that .* expressions
naming a non-static member be used as part of a function call.  Still, we should
not ICE.
Comment 7 CVS Commits 2004-05-31 21:04:24 UTC
Subject: Bug 15696

CVSROOT:	/cvs/gcc
Module name:	gcc
Branch: 	gcc-3_4-branch
Changes by:	mmitchel@gcc.gnu.org	2004-05-31 21:04:15

Modified files:
	gcc/testsuite  : ChangeLog 
	gcc/cp         : ChangeLog call.c cp-tree.h cvt.c name-lookup.c 
	                 pt.c tree.c typeck.c 
	gcc/testsuite/g++.dg/ext: packed3.C packed4.C 
	gcc/testsuite/g++.dg/template: friend.C 
Added files:
	gcc/testsuite/g++.dg/expr: ptrmem5.C 
	gcc/testsuite/g++.dg/ext: packed6.C 
	gcc/testsuite/g++.dg/template: friend27.C friend28.C 
	gcc/testsuite/g++.dg/warn: Wreturn-1.C 

Log message:
	PR c++/15742
	* call.c (build_over_call): Set
	current_function_returns_abnormally even in template functions.
	
	PR c++/15696
	* cp-tree.h (invalid_nonstatic_memfn_p): New function.
	* cvt.c (convert_to_void): Use it.
	* typeck.c (invalid_nonstatic_memfn_p): New function.
	(decay_conversion): Use it.
	
	PR c++/15625
	* pt.c (tsubst_decl): Set DECL_FRIEND_CONTEXT for instantiated
	templates.
	
	PR c++/15629
	* name-lookup.c (arg_assoc_class): Do not find template
	specializations.
	
	PR c++/15209
	* tree.c (lvalue_p_1): Only consider the right-hand side of "."
	expressions when determining whether or not an express is packed.
	
	PR c++/15742
	* g++.dg/warn/Wreturn-1.C: New test.
	
	PR c++/15696
	* g++.dg/expr/ptrmem5.C: New test.
	
	PR c++/15625
	* g++.dg/template/friend27.C: New test.
	
	PR c++/15629
	* g++.dg/template/friend28.C: New test.
	* g++.dg/template/friend.C: Do not depend on <iostream>.  Add
	error message.
	
	PR c++/15209
	* g++.dg/ext/packed3.C: Remove bogus error.
	* g++.dg/ext/packed4.C: Remove bogus check.
	* g++.dg/ext/packed6.C: New test.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.3389.2.187&r2=1.3389.2.188
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.3892.2.109&r2=1.3892.2.110
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/call.c.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.452.2.16&r2=1.452.2.17
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/cp-tree.h.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.946.4.12&r2=1.946.4.13
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/cvt.c.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.151.4.1&r2=1.151.4.2
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/name-lookup.c.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.34.2.13&r2=1.34.2.14
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/pt.c.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.816.2.26&r2=1.816.2.27
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/tree.c.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.360.4.5&r2=1.360.4.6
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/typeck.c.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.519.2.18&r2=1.519.2.19
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/expr/ptrmem5.C.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=NONE&r2=1.1.2.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/ext/packed6.C.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=NONE&r2=1.1.2.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/ext/packed3.C.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.1&r2=1.1.24.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/ext/packed4.C.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.1&r2=1.1.24.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/template/friend27.C.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=NONE&r2=1.1.2.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/template/friend28.C.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=NONE&r2=1.1.2.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/template/friend.C.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.5&r2=1.5.56.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/warn/Wreturn-1.C.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=NONE&r2=1.1.2.1

Comment 8 CVS Commits 2004-05-31 21:24:36 UTC
Subject: Bug 15696

CVSROOT:	/cvs/gcc
Module name:	gcc
Changes by:	mmitchel@gcc.gnu.org	2004-05-31 21:24:31

Modified files:
	gcc/cp         : call.c cp-tree.h cvt.c name-lookup.c pt.c 
	                 tree.c typeck.c 
	gcc/testsuite/g++.dg/ext: packed3.C packed4.C 
	gcc/testsuite/g++.dg/template: friend.C 
Added files:
	gcc/testsuite/g++.dg/expr: ptrmem5.C 
	gcc/testsuite/g++.dg/ext: packed6.C 
	gcc/testsuite/g++.dg/template: friend27.C friend28.C 
	gcc/testsuite/g++.dg/warn: Wreturn-1.C 

Log message:
	PR c++/15742
	* call.c (build_over_call): Set
	current_function_returns_abnormally even in template functions.
	
	PR c++/15696
	* cp-tree.h (invalid_nonstatic_memfn_p): New function.
	* cvt.c (convert_to_void): Use it.
	* typeck.c (invalid_nonstatic_memfn_p): New function.
	(decay_conversion): Use it.
	
	PR c++/15625
	* pt.c (tsubst_decl): Set DECL_FRIEND_CONTEXT for instantiated
	templates.
	
	PR c++/15629
	* name-lookup.c (arg_assoc_class): Do not find template
	specializations.
	
	PR c++/15209
	* tree.c (lvalue_p_1): Only consider the right-hand side of "."
	expressions when determining whether or not an express is packed.
	
	PR c++/15742
	* g++.dg/warn/Wreturn-1.C: New test.
	
	PR c++/15696
	* g++.dg/expr/ptrmem5.C: New test.
	
	PR c++/15625
	* g++.dg/template/friend27.C: New test.
	
	PR c++/15629
	* g++.dg/template/friend28.C: New test.
	* g++.dg/template/friend.C: Do not depend on <iostream>.  Add
	error message.
	
	PR c++/15209
	* g++.dg/ext/packed3.C: Remove bogus error.
	* g++.dg/ext/packed4.C: Remove bogus check.
	* g++.dg/ext/packed6.C: New test.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/call.c.diff?cvsroot=gcc&r1=1.476&r2=1.477
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/cp-tree.h.diff?cvsroot=gcc&r1=1.969&r2=1.970
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/cvt.c.diff?cvsroot=gcc&r1=1.156&r2=1.157
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/name-lookup.c.diff?cvsroot=gcc&r1=1.56&r2=1.57
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/pt.c.diff?cvsroot=gcc&r1=1.856&r2=1.857
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/tree.c.diff?cvsroot=gcc&r1=1.374&r2=1.375
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/typeck.c.diff?cvsroot=gcc&r1=1.547&r2=1.548
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/expr/ptrmem5.C.diff?cvsroot=gcc&r1=1.1&r2=1.2
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/ext/packed6.C.diff?cvsroot=gcc&r1=1.1&r2=1.2
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/ext/packed3.C.diff?cvsroot=gcc&r1=1.1&r2=1.2
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/ext/packed4.C.diff?cvsroot=gcc&r1=1.1&r2=1.2
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/template/friend27.C.diff?cvsroot=gcc&r1=1.1&r2=1.2
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/template/friend28.C.diff?cvsroot=gcc&r1=1.1&r2=1.2
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/template/friend.C.diff?cvsroot=gcc&r1=1.5&r2=1.6
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/warn/Wreturn-1.C.diff?cvsroot=gcc&r1=1.1&r2=1.2

Comment 9 Mark Mitchell 2004-05-31 21:29:23 UTC
Fixed in GCC 3.4.1.